package gr.cite.annotation.integrationevent.inbox;

import org.springframework.boot.context.properties.ConfigurationProperties;

import java.util.List;

@ConfigurationProperties(prefix = "queue.task.listener.options")
public class InboxProperties {

    private final String exchange;

    private final List<String> tenantRemovalTopic;

    private final List<String> tenantTouchTopic;

    private final List<String> userRemovalTopic;

    private final List<String> userTouchTopic;

    private final List<String> annotationEntityTouchTopic;

    public InboxProperties(
            String exchange,
            List<String> tenantRemovalTopic,
            List<String> tenantTouchTopic,
            List<String> userRemovalTopic,
            List<String> userTouchTopic,
            List<String> annotationEntityTouchTopic) {
        this.exchange = exchange;
        this.tenantRemovalTopic = tenantRemovalTopic;
        this.tenantTouchTopic = tenantTouchTopic;
        this.userRemovalTopic = userRemovalTopic;
        this.userTouchTopic = userTouchTopic;
        this.annotationEntityTouchTopic = annotationEntityTouchTopic;
    }

    public List<String> getTenantRemovalTopic() {
        return tenantRemovalTopic;
    }

    public List<String> getTenantTouchTopic() {
        return tenantTouchTopic;
    }

    public List<String> getUserRemovalTopic() {
        return userRemovalTopic;
    }

    public List<String> getUserTouchTopic() {
        return userTouchTopic;
    }

    public List<String> getAnnotationEntityTouchTopic() {
        return annotationEntityTouchTopic;
    }

    public String getExchange() {
        return exchange;
    }

}
