package eu.eudat.data.tenant;

import eu.eudat.commons.scope.tenant.TenantScoped;
import jakarta.persistence.*;
import org.hibernate.annotations.Filter;
import org.hibernate.annotations.FilterDef;
import org.hibernate.annotations.ParamDef;


import java.io.Serializable;
import java.util.UUID;

@MappedSuperclass
//@Getter
//@Setter
//@NoArgsConstructor
@FilterDef(name = TenantScopedBaseEntity.tenantFilter, parameters = {@ParamDef(name = TenantScopedBaseEntity.tenantFilterTenantParam, type = String.class)})
@Filter(name = "tenantFilter", condition = "tenant = (cast(:tenantId as uuid))")
//@EntityListeners(TenantListener.class)
public abstract class TenantScopedBaseEntity implements TenantScoped, Serializable {
    private static final long serialVersionUID = 1L;
    public static final String tenantFilter = "tenantFilter";
    public static final String tenantFilterTenantParam = "tenantId";

    @Column(name = "tenant", columnDefinition = "uuid", nullable = true)
    private UUID tenantId;
    public static final String _tenantId = "tenantId";
    public UUID getTenantId() {
        return tenantId;
    }

    @Override
    public void setTenantId(UUID tenantId) {
        this.tenantId = tenantId;
    }
}
