package eu.eudat.query.lookup;


import eu.eudat.commons.enums.LockTargetType;
import eu.eudat.query.LockQuery;
import gr.cite.tools.data.query.Lookup;
import gr.cite.tools.data.query.QueryFactory;

import java.util.List;
import java.util.UUID;

public class LockLookup extends Lookup {

    private List<UUID> ids;

    private List<UUID> targetIds;

    private List<LockTargetType> targetTypes;

    private List<UUID> excludedIds;

    public List<UUID> getIds() {
        return ids;
    }

    public void setIds(List<UUID> ids) {
        this.ids = ids;
    }

    public List<UUID> getTargetIds() {
        return targetIds;
    }

    public void setTargetIds(List<UUID> targetIds) {
        this.targetIds = targetIds;
    }

    public List<UUID> getExcludedIds() {
        return excludedIds;
    }

    public void setExcludedIds(List<UUID> excludeIds) {
        this.excludedIds = excludeIds;
    }

    public List<LockTargetType> getTargetTypes() {
        return targetTypes;
    }

    public void setTargetTypes(List<LockTargetType> targetTypes) {
        this.targetTypes = targetTypes;
    }

    public LockQuery enrich(QueryFactory queryFactory) {
        LockQuery query = queryFactory.query(LockQuery.class);
        if (this.ids != null) query.ids(this.ids);
        if (this.targetIds != null) query.targetIds(this.targetIds);
        if (this.targetTypes != null) query.targetTypes(this.targetTypes);
        if (this.excludedIds != null) query.excludedIds(this.excludedIds);

        this.enrichCommon(query);

        return query;
    }

}
