package eu.eudat.controllers.old;

import eu.eudat.authorization.Permission;
import eu.eudat.logic.managers.ValidationManager;
import gr.cite.commons.web.authz.service.AuthorizationService;
import gr.cite.tools.exception.MyNotFoundException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@CrossOrigin
@RequestMapping(value = {"/api"})
public class Validation  {

	private ValidationManager validationManager;
	private final AuthorizationService authorizationService;

	@Autowired
	public Validation(ValidationManager validationManager, AuthorizationService authorizationService) {
		this.validationManager = validationManager;
		this.authorizationService = authorizationService;
	}

	@RequestMapping(method = RequestMethod.GET, value = {"/external/validation"}, produces = "application/json")
	public @ResponseBody
	Boolean validate(
			@RequestParam(value = "query", required = false) String query, @RequestParam(value = "type", required = false) String type
	) throws MyNotFoundException {
		this.authorizationService.authorizeForce(Permission.AuthenticatedRole);

		Boolean isValid = this.validationManager.validateIdentifier(query, type);
		return isValid;
	}
}

